#ifndef _LOG_H
#define _LOG_H

//#define DONT_LOG
//#define DONT_LOG_TO_SCREEN

#include <stdio.h>



#define MAX_LOG_BUFFER_SIZE 255

#ifdef DONT_LOG
#define Log(fmt, ...)
#define rfbLog(fmt, ...)
#define rfbErr(fmt, ...)
#else
#define Log(fmt, ...) \
    do {\
        char szBuf[MAX_LOG_BUFFER_SIZE];\
        _snprintf(szBuf, MAX_LOG_BUFFER_SIZE-1, fmt, __VA_ARGS__);\
        doLog(__FILE__, __LINE__, szBuf);\
    } while(0)
#define rfbLog(fmt, ...) \
    do {\
        char szBuf[MAX_LOG_BUFFER_SIZE];\
        _snprintf(szBuf, MAX_LOG_BUFFER_SIZE-1, fmt, __VA_ARGS__);\
        doLog(__FILE__, __LINE__, szBuf);\
    } while(0)
#define rfbErr(fmt, ...) \
    do {\
        char szBuf[MAX_LOG_BUFFER_SIZE];\
        _snprintf(szBuf, MAX_LOG_BUFFER_SIZE-1, fmt, __VA_ARGS__);\
        doLog(__FILE__, __LINE__, szBuf);\
    } while(0)
#endif

#ifdef __cplusplus
extern "C"  {
#endif

void initLog(char *szFilename);
void doLog(char *szFile, int iLine, char *szBuf);
void closeLog(void);

#ifdef __cplusplus
} /* extern "C" */
#endif

#endif
